From 81125b1f916295de027e835048eeb6534a00e764 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:54:10 +0000
Subject: [PATCH 703/1001] Add a class for widget-specific views


---

diff --git a/hubs/widgets/chrome.py b/hubs/widgets/chrome.py
old mode 100755
new mode 100644
index b869094..cc9b4ca
--- a/hubs/widgets/chrome.py
+++ b/hubs/widgets/chrome.py
@@ -1,6 +1,6 @@
 from __future__ import unicode_literals
 
-from hubs.widgets.base import wraps
+from functools import wraps
 from hubs.widgets import templating
 
 _panel_template = templating.environment.get_template(
@@ -9,8 +9,9 @@ _panel_heading_template = templating.environment.get_template(
     'templates/panel_heading.html')
 
 
+# FIXME: replace with template block extension
 def panel(title=None, klass="panel-default", key=None, footer_template=None):
-    def decorator(func):
+    def decorator(view, func):
         @wraps(func)
         def inner(*args, **kwargs):
             heading = ''
@@ -18,7 +19,8 @@ def panel(title=None, klass="panel-default", key=None, footer_template=None):
             if title:
                 heading = _panel_heading_template.render(title=title)
             if footer_template:
-                footer = footer_template.render(**kwargs)
+                footer = templating.environment.get_template(
+                    footer_template).render(**kwargs)
             content = func(*args, **kwargs)
             if key and not kwargs.get(key):
                 return content
diff --git a/hubs/widgets/view.py b/hubs/widgets/view.py
new file mode 100644
index 0000000..f6f486a
--- /dev/null
+++ b/hubs/widgets/view.py
@@ -0,0 +1,111 @@
+from __future__ import unicode_literals, absolute_import
+
+import flask
+from flask.views import View
+
+
+class WidgetView(View):
+    """
+    This class is the skeleton of a widget-specific view.
+
+    You must subclass this class to use it in your view:
+
+    - the `name` attribute must be defined
+    - the `template_name` attribute must be defined, or the `get_template()`
+      method must be implemented
+    - the `get_context()` method must be implemented
+
+    Every widget must have a view with the name "`root`" registered to `['/']`,
+    which will be the main entry point for the widget.
+
+    The resulting endpoint will be composed using the widget name and the view
+    name as `<widget_name>_<view_name>`, for example `meetings_root`.
+    Remember that when you want to reverse the URL with `url_for`.
+
+    When reversing the URL, you need to pass the ``hub`` and ``idx`` kwargs,
+    which are respectively the hub name (`Hub.name`) and the widget instance
+    (the database record) primary key (`Widget.idx`).
+
+    Attributes:
+        name (str): The view name. It will be used to compose the URL endpoint,
+            following the "`<widget.name>_<view.name>`" convention.
+        url_rules (list): A list of URL rules that this view must be registered
+            for (like the `rule` parameter of Flask's `add_url_rule()`).
+        template_name (str): The template name to use for this view. It will be
+            looked for in the widget's template environment.
+        chrome (function): An optional chrome template wrapper.
+
+    This class is Flask-specific. If another framework were to be switched to,
+    it would have to be re-implemented.
+    """
+
+    name = None
+    url_rules = []
+    template_name = None
+    chrome = None
+
+    def __init__(self, widget):
+        """
+        Args:
+            widget (hubs.widgets.base.Widget): the widget that uses this view.
+        """
+        self.widget = widget
+        if self.name is None:
+            raise NotImplementedError
+
+    def get_context(self, instance, *args, **kwargs):
+        """
+        Return the template context for this view.
+
+        Args:
+            instance (hubs.models.Widget): the widget instance.
+        """
+        raise NotImplementedError
+
+    def get_template(self):
+        """
+        Return the template object, looking for `template_name` in the widget's
+        template environment.
+        """
+        if self.template_name is None:
+            return NotImplementedError
+        tpl_env = self.widget.get_template_environment()
+        template = tpl_env.get_template(self.template_name)
+        return template
+
+    def get_extra_context(self, instance, *args, **kwargs):
+        """
+        Add extra data to the template context.
+        """
+        # Put source links in all API results
+        return {
+            'source_url': flask.url_for(
+                'widget_source', name=self.widget.name),
+            'widget_url': flask.url_for(
+                '%s_root' % self.widget.name,
+                hub=instance.hub.name, idx=instance.idx),
+            'edit_url': flask.url_for(
+                'widget_edit', hub=instance.hub.name, idx=instance.idx),
+            'widget': self.widget,
+            'widget_instance': instance,
+        }
+
+    def _get_instance(self, *args, **kwargs):
+        from hubs.views.utils import get_widget_instance
+        hubname = kwargs.pop("hub")
+        widgetidx = kwargs.pop("idx")
+        return get_widget_instance(hubname, widgetidx)
+
+    def dispatch_request(self, *args, **kwargs):
+        """
+        The `dispatch_request` method that subclasses of `flask.views.View`
+        must implement. It binds the other methods together.
+        """
+        instance = self._get_instance(*args, **kwargs)
+        context = self.get_context(instance, *args, **kwargs)
+        context.update(self.get_extra_context(instance, *args, **kwargs))
+        template = self.get_template()
+        if self.chrome is None:
+            return self.get_template().render(**context)
+        else:
+            return self.chrome(template.render)(**context)

